Index: etc/rc.d/dhclient
===================================================================
RCS file: /cvsroot/src/etc/rc.d/dhclient,v
retrieving revision 1.9
diff -u -p -r1.9 dhclient
--- etc/rc.d/dhclient	13 Aug 2004 18:08:03 -0000	1.9
+++ etc/rc.d/dhclient	2 Oct 2008 09:03:57 -0000
@@ -17,6 +17,60 @@ name="dhclient"
 rcvar=$name
 command="/sbin/${name}"
 pidfile="/var/run/${name}.pid"
+start_precmd='wait_for_network && setconf'
+
+wait_for_network()
+{
+	local if= n
+	local wait_max=20 # seconds
+	local waiting=no
+
+	if [ -z "$dhclient_wait_for_network" ] ||
+	    ! checkyesno dhclient_wait_for_network; then
+		return 0
+	fi
+
+	# expect interface name as last word in $dhclient_flags
+	if=${dhclient_flags##* }
+	case $if in
+		[a-z]*[0-9]) ;;
+		*) return 1 ;;
+	esac
+
+	n=0
+	while ! ifconfig -s $if; do
+		[ $n -ge $wait_max ] && break
+		if [ $waiting = 'no' ]; then
+			echo -n "$name waiting for network"
+			waiting='yes'
+		fi
+		echo -n .
+		sleep 1
+		n=$((n+1))
+	done
+	[ $waiting = 'yes' ] && echo
+
+	return 0
+}
+
+setconf()
+{
+	local bco="${bootconf_option:+.${bootconf_option}}"
+	local src=
+
+	if [ -n "$bco" -a -f /etc/etc.current/dhclient.conf"$bco" ]; then
+		src=etc.current/dhclient.conf"$bco"
+	elif [ -f /etc/etc.current/dhclient.conf ]; then
+		src=etc.current/dhclient.conf
+	elif [ -f /etc/dhclient.conf.default ]; then
+		src=dhclient.conf.default
+	else
+		return 0
+	fi
+
+	ln -sf "$src" /etc/dhclient.conf
+	return 0
+}
 
 load_rc_config $name
 run_rc_command "$1"
Index: etc/defaults/rc.conf
===================================================================
RCS file: /cvsroot/src/etc/defaults/rc.conf,v
retrieving revision 1.109
diff -u -p -r1.109 rc.conf
--- etc/defaults/rc.conf	1 Oct 2009 16:36:20 -0000	1.109
+++ etc/defaults/rc.conf	1 May 2010 20:18:24 -0000
@@ -177,6 +184,7 @@ dhcpcd=NO
 dhcpcd_flags="-q"				# For ifconfig_XXX=dhcp.
 dhclient=NO					# behave as a DHCP client
 			dhclient_flags=""	# blank: config all interfaces
+dhclient_wait_for_network=NO
 ntpdate=NO  		ntpdate_flags="-b -s"	# May need '-u' thru firewall
 ppp_peers=""					# /etc/ppp/peers to call
 ip6mode=host					# host, autohost or router
